# -------------------------------------------------------------------------------- #
# Model Constants
# -------------------------------------------------------------------------------- #
# This file is auto-generated by scripts/generate_model_constants.py
# DO NOT EDIT MANUALLY
# -------------------------------------------------------------------------------- #

# -------------------------------------------------------------------------------- #
# Imports
# -------------------------------------------------------------------------------- #
# Built-in imports
from typing import Literal, Dict, TypeAlias


# -------------------------------------------------------------------------------- #
# Model Types
# -------------------------------------------------------------------------------- #

ResourceType = Literal[
    "completion",
]


# -------------------------------------------------------------------------------- #
# Model Provider
# -------------------------------------------------------------------------------- #

ModelProvider = Literal[
    "anthropic",
    "deepseek",
    "openai",
]


# -------------------------------------------------------------------------------- #
# Model Alias and IDs
# -------------------------------------------------------------------------------- #

ModelAlias = Literal[
    "claude-3-5-haiku",
    "claude-3-5-sonnet",
    "claude-3-7-sonnet",
    "claude-3-haiku",
    "claude-3-opus",
    "claude-3-sonnet",
    "deepseek-chat",
    "deepseek-reasoner",
    "gpt-4.5-preview",
    "gpt-4o",
    "gpt-4o-mini",
    "o1",
    "o1-mini",
    "o1-preview",
    "o1-pro",
    "o3-mini",
]

ModelId = Literal[
    "claude-3-5-haiku-20241022",
    "claude-3-5-sonnet-20240620",
    "claude-3-5-sonnet-20241022",
    "claude-3-7-sonnet-20250219",
    "claude-3-haiku-20240307",
    "claude-3-opus-20240229",
    "claude-3-sonnet-20240229",
    "deepseek-chat",
    "deepseek-reasoner",
    "gpt-4.5-preview-2025-02-27",
    "gpt-4o-2024-05-13",
    "gpt-4o-2024-08-06",
    "gpt-4o-2024-11-20",
    "gpt-4o-mini-2024-07-18",
    "o1-2024-12-17",
    "o1-mini-2024-09-12",
    "o1-preview-2024-09-12",
    "o1-pro-2025-03-19",
    "o3-mini-2025-01-31",
]


# -------------------------------------------------------------------------------- #
# Model Breakdown by Provider
# -------------------------------------------------------------------------------- #

OpenAIModels = Literal[
    "gpt-4.5-preview",
    "gpt-4.5-preview-2025-02-27",
    "gpt-4o",
    "gpt-4o-2024-05-13",
    "gpt-4o-2024-08-06",
    "gpt-4o-2024-11-20",
    "gpt-4o-mini",
    "gpt-4o-mini-2024-07-18",
    "o1",
    "o1-2024-12-17",
    "o1-mini",
    "o1-mini-2024-09-12",
    "o1-preview",
    "o1-preview-2024-09-12",
    "o1-pro",
    "o1-pro-2025-03-19",
    "o3-mini",
    "o3-mini-2025-01-31",
]

DeepSeekModels = Literal[
    "deepseek-chat",
    "deepseek-reasoner",
]

AnthropicModels = Literal[
    "claude-3-5-haiku",
    "claude-3-5-haiku-20241022",
    "claude-3-5-sonnet",
    "claude-3-5-sonnet-20240620",
    "claude-3-5-sonnet-20241022",
    "claude-3-7-sonnet",
    "claude-3-7-sonnet-20250219",
    "claude-3-haiku",
    "claude-3-haiku-20240307",
    "claude-3-opus",
    "claude-3-opus-20240229",
    "claude-3-sonnet",
    "claude-3-sonnet-20240229",
]

# -------------------------------------------------------------------------------- #
# Model Breakdown by Function
# -------------------------------------------------------------------------------- #


CompletionModels = Literal[
    "claude-3-5-haiku-20241022",
    "claude-3-5-sonnet-20240620",
    "claude-3-5-sonnet-20241022",
    "claude-3-7-sonnet-20250219",
    "claude-3-haiku-20240307",
    "claude-3-opus-20240229",
    "claude-3-sonnet-20240229",
    "deepseek-chat",
    "deepseek-reasoner",
    "gpt-4.5-preview-2025-02-27",
    "gpt-4o-2024-05-13",
    "gpt-4o-2024-08-06",
    "gpt-4o-2024-11-20",
    "gpt-4o-mini-2024-07-18",
    "o1-2024-12-17",
    "o1-mini-2024-09-12",
    "o1-preview-2024-09-12",
    "o1-pro-2025-03-19",
    "o3-mini-2025-01-31",
]

# EmbeddingModels = Literal[
#     "text-embedding-3-small",
#     "text-embedding-3-large",
# ]

# -------------------------------------------------------------------------------- #
# ALL MODEL NAMES
# Type alias combining all provider models
# -------------------------------------------------------------------------------- #

ModelName: TypeAlias = Literal[OpenAIModels, DeepSeekModels, AnthropicModels]

# -------------------------------------------------------------------------------- #
# Model Name to Provider Mapping
# -------------------------------------------------------------------------------- #

PROVIDER_MODEL_NAMES: Dict[ModelName, ModelProvider] = {
    "claude-3-5-haiku": "anthropic",
    "claude-3-5-haiku-20241022": "anthropic",
    "claude-3-5-sonnet": "anthropic",
    "claude-3-5-sonnet-20240620": "anthropic",
    "claude-3-5-sonnet-20241022": "anthropic",
    "claude-3-7-sonnet": "anthropic",
    "claude-3-7-sonnet-20250219": "anthropic",
    "claude-3-haiku": "anthropic",
    "claude-3-haiku-20240307": "anthropic",
    "claude-3-opus": "anthropic",
    "claude-3-opus-20240229": "anthropic",
    "claude-3-sonnet": "anthropic",
    "claude-3-sonnet-20240229": "anthropic",
    "deepseek-chat": "deepseek",
    "deepseek-reasoner": "deepseek",
    "gpt-4.5-preview": "openai",
    "gpt-4.5-preview-2025-02-27": "openai",
    "gpt-4o": "openai",
    "gpt-4o-2024-05-13": "openai",
    "gpt-4o-2024-08-06": "openai",
    "gpt-4o-2024-11-20": "openai",
    "gpt-4o-mini": "openai",
    "gpt-4o-mini-2024-07-18": "openai",
    "o1": "openai",
    "o1-2024-12-17": "openai",
    "o1-mini": "openai",
    "o1-mini-2024-09-12": "openai",
    "o1-preview": "openai",
    "o1-preview-2024-09-12": "openai",
    "o1-pro": "openai",
    "o1-pro-2025-03-19": "openai",
    "o3-mini": "openai",
    "o3-mini-2025-01-31": "openai",
}

# -------------------------------------------------------------------------------- #
# Model Name to Resource Type Mapping
# -------------------------------------------------------------------------------- #

MODEL_NAMES_TO_RESOURCE_TYPE: Dict[ModelName, ResourceType] = {
    "claude-3-5-haiku": "completion",
    "claude-3-5-haiku-20241022": "completion",
    "claude-3-5-sonnet": "completion",
    "claude-3-5-sonnet-20240620": "completion",
    "claude-3-5-sonnet-20241022": "completion",
    "claude-3-7-sonnet": "completion",
    "claude-3-7-sonnet-20250219": "completion",
    "claude-3-haiku": "completion",
    "claude-3-haiku-20240307": "completion",
    "claude-3-opus": "completion",
    "claude-3-opus-20240229": "completion",
    "claude-3-sonnet": "completion",
    "claude-3-sonnet-20240229": "completion",
    "deepseek-chat": "completion",
    "deepseek-reasoner": "completion",
    "gpt-4.5-preview": "completion",
    "gpt-4.5-preview-2025-02-27": "completion",
    "gpt-4o": "completion",
    "gpt-4o-2024-05-13": "completion",
    "gpt-4o-2024-08-06": "completion",
    "gpt-4o-2024-11-20": "completion",
    "gpt-4o-mini": "completion",
    "gpt-4o-mini-2024-07-18": "completion",
    "o1": "completion",
    "o1-2024-12-17": "completion",
    "o1-mini": "completion",
    "o1-mini-2024-09-12": "completion",
    "o1-preview": "completion",
    "o1-preview-2024-09-12": "completion",
    "o1-pro": "completion",
    "o1-pro-2025-03-19": "completion",
    "o3-mini": "completion",
    "o3-mini-2025-01-31": "completion",
}